module Visualization.Scale.ColorInterpolators exposing (viridis)

import Array exposing (Array)
import Color exposing (Color, rgb, black)


mkInterpolator : Array Color -> Float -> Color
mkInterpolator range =
    let
        n =
            Array.length range
    in
        \t ->
            Maybe.withDefault black <| Array.get (max 0 (min (n - 1) (floor (t * toFloat n)))) range


viridis : Float -> Color
viridis =
    mkInterpolator <|
        Array.fromList
            [ rgb 68 1 84
            , rgb 68 2 86
            , rgb 69 4 87
            , rgb 69 5 89
            , rgb 70 7 90
            , rgb 70 8 92
            , rgb 70 10 93
            , rgb 70 11 94
            , rgb 71 13 96
            , rgb 71 14 97
            , rgb 71 16 99
            , rgb 71 17 100
            , rgb 71 19 101
            , rgb 72 20 103
            , rgb 72 22 104
            , rgb 72 23 105
            , rgb 72 24 106
            , rgb 72 26 108
            , rgb 72 27 109
            , rgb 72 28 110
            , rgb 72 29 111
            , rgb 72 31 112
            , rgb 72 32 113
            , rgb 72 33 115
            , rgb 72 35 116
            , rgb 72 36 117
            , rgb 72 37 118
            , rgb 72 38 119
            , rgb 72 40 120
            , rgb 72 41 121
            , rgb 71 42 122
            , rgb 71 44 122
            , rgb 71 45 123
            , rgb 71 46 124
            , rgb 71 47 125
            , rgb 70 48 126
            , rgb 70 50 126
            , rgb 70 51 127
            , rgb 70 52 128
            , rgb 69 53 129
            , rgb 69 55 129
            , rgb 69 56 130
            , rgb 68 57 131
            , rgb 68 58 131
            , rgb 68 59 132
            , rgb 67 61 132
            , rgb 67 62 133
            , rgb 66 63 133
            , rgb 66 64 134
            , rgb 66 65 134
            , rgb 65 66 135
            , rgb 65 68 135
            , rgb 64 69 136
            , rgb 64 70 136
            , rgb 63 71 136
            , rgb 63 72 137
            , rgb 62 73 137
            , rgb 62 74 137
            , rgb 62 76 138
            , rgb 61 77 138
            , rgb 61 78 138
            , rgb 60 79 138
            , rgb 60 80 139
            , rgb 59 81 139
            , rgb 59 82 139
            , rgb 58 83 139
            , rgb 58 84 140
            , rgb 57 85 140
            , rgb 57 86 140
            , rgb 56 88 140
            , rgb 56 89 140
            , rgb 55 90 140
            , rgb 55 91 141
            , rgb 54 92 141
            , rgb 54 93 141
            , rgb 53 94 141
            , rgb 53 95 141
            , rgb 52 96 141
            , rgb 52 97 141
            , rgb 51 98 141
            , rgb 51 99 141
            , rgb 50 100 142
            , rgb 50 101 142
            , rgb 49 102 142
            , rgb 49 103 142
            , rgb 49 104 142
            , rgb 48 105 142
            , rgb 48 106 142
            , rgb 47 107 142
            , rgb 47 108 142
            , rgb 46 109 142
            , rgb 46 110 142
            , rgb 46 111 142
            , rgb 45 112 142
            , rgb 45 113 142
            , rgb 44 113 142
            , rgb 44 114 142
            , rgb 44 115 142
            , rgb 43 116 142
            , rgb 43 117 142
            , rgb 42 118 142
            , rgb 42 119 142
            , rgb 42 120 142
            , rgb 41 121 142
            , rgb 41 122 142
            , rgb 41 123 142
            , rgb 40 124 142
            , rgb 40 125 142
            , rgb 39 126 142
            , rgb 39 127 142
            , rgb 39 128 142
            , rgb 38 129 142
            , rgb 38 130 142
            , rgb 38 130 142
            , rgb 37 131 142
            , rgb 37 132 142
            , rgb 37 133 142
            , rgb 36 134 142
            , rgb 36 135 142
            , rgb 35 136 142
            , rgb 35 137 142
            , rgb 35 138 141
            , rgb 34 139 141
            , rgb 34 140 141
            , rgb 34 141 141
            , rgb 33 142 141
            , rgb 33 143 141
            , rgb 33 144 141
            , rgb 33 145 140
            , rgb 32 146 140
            , rgb 32 146 140
            , rgb 32 147 140
            , rgb 31 148 140
            , rgb 31 149 139
            , rgb 31 150 139
            , rgb 31 151 139
            , rgb 31 152 139
            , rgb 31 153 138
            , rgb 31 154 138
            , rgb 30 155 138
            , rgb 30 156 137
            , rgb 30 157 137
            , rgb 31 158 137
            , rgb 31 159 136
            , rgb 31 160 136
            , rgb 31 161 136
            , rgb 31 161 135
            , rgb 31 162 135
            , rgb 32 163 134
            , rgb 32 164 134
            , rgb 33 165 133
            , rgb 33 166 133
            , rgb 34 167 133
            , rgb 34 168 132
            , rgb 35 169 131
            , rgb 36 170 131
            , rgb 37 171 130
            , rgb 37 172 130
            , rgb 38 173 129
            , rgb 39 173 129
            , rgb 40 174 128
            , rgb 41 175 127
            , rgb 42 176 127
            , rgb 44 177 126
            , rgb 45 178 125
            , rgb 46 179 124
            , rgb 47 180 124
            , rgb 49 181 123
            , rgb 50 182 122
            , rgb 52 182 121
            , rgb 53 183 121
            , rgb 55 184 120
            , rgb 56 185 119
            , rgb 58 186 118
            , rgb 59 187 117
            , rgb 61 188 116
            , rgb 63 188 115
            , rgb 64 189 114
            , rgb 66 190 113
            , rgb 68 191 112
            , rgb 70 192 111
            , rgb 72 193 110
            , rgb 74 193 109
            , rgb 76 194 108
            , rgb 78 195 107
            , rgb 80 196 106
            , rgb 82 197 105
            , rgb 84 197 104
            , rgb 86 198 103
            , rgb 88 199 101
            , rgb 90 200 100
            , rgb 92 200 99
            , rgb 94 201 98
            , rgb 96 202 96
            , rgb 99 203 95
            , rgb 101 203 94
            , rgb 103 204 92
            , rgb 105 205 91
            , rgb 108 205 90
            , rgb 110 206 88
            , rgb 112 207 87
            , rgb 115 208 86
            , rgb 117 208 84
            , rgb 119 209 83
            , rgb 122 209 81
            , rgb 124 210 80
            , rgb 127 211 78
            , rgb 129 211 77
            , rgb 132 212 75
            , rgb 134 213 73
            , rgb 137 213 72
            , rgb 139 214 70
            , rgb 142 214 69
            , rgb 144 215 67
            , rgb 147 215 65
            , rgb 149 216 64
            , rgb 152 216 62
            , rgb 155 217 60
            , rgb 157 217 59
            , rgb 160 218 57
            , rgb 162 218 55
            , rgb 165 219 54
            , rgb 168 219 52
            , rgb 170 220 50
            , rgb 173 220 48
            , rgb 176 221 47
            , rgb 178 221 45
            , rgb 181 222 43
            , rgb 184 222 41
            , rgb 186 222 40
            , rgb 189 223 38
            , rgb 192 223 37
            , rgb 194 223 35
            , rgb 197 224 33
            , rgb 200 224 32
            , rgb 202 225 31
            , rgb 205 225 29
            , rgb 208 225 28
            , rgb 210 226 27
            , rgb 213 226 26
            , rgb 216 226 25
            , rgb 218 227 25
            , rgb 221 227 24
            , rgb 223 227 24
            , rgb 226 228 24
            , rgb 229 228 25
            , rgb 231 228 25
            , rgb 234 229 26
            , rgb 236 229 27
            , rgb 239 229 28
            , rgb 241 229 29
            , rgb 244 230 30
            , rgb 246 230 32
            , rgb 248 230 33
            , rgb 251 231 35
            , rgb 253 231 37
            ]
